## deepin-system-upgrade 6.0.2.3

=== src/deepin-system-upgrade-tool/CMakeLists.txt ===
# 学习 cmake
# 时建议直接从命令列表作为入口，遇到不清楚意思的命令都可以在此处查阅：
# https://cmake.org/cmake/help/latest/manual/cmake-commands.7.html
# 另外下面是完整的文档入口：
# https://cmake.org/cmake/help/latest/

# 设置运行该脚本所需的 cmake 最低版本
cmake_minimum_required(VERSION 3.9)

# 使用 set 命令设置一个变量
set(PROJECT_NAME deepin-system-upgrade-tool)
# set(TEST_NAME uos-updater-test)

# 设置项目名称
project(${PROJECT_NAME})

set(CMAKE_CXX_STANDARD 20)
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "-O1 -DNDEBUG")

# 指定所有源码文件
# 使用了 cmake 的 file 命令，递归查找项目目录下所有头文件和源码文件，
# 并将结果放入 SRCS 变量中，SRCS 变量可用于后续使用

file(GLOB CORE_SRCS
    "src/core/*.h"
    "src/core/*.cpp"
)

file(GLOB SETTINGS_SRCS
    "src/settings/*.h"
    "src/settings/*.cpp"
)

file(GLOB WIDGETS_SRCS
    "src/widgets/*.h"
    "src/widgets/*.cpp"
)

file(GLOB TOOL_SRCS
    "src/tool/*.h"
    "src/tool/*.cpp"
    "src/tool/image_preparation/*.cpp"
    "src/tool/upgrade_check/*.cpp"
    "src/tool/upgrade_progress/*.cpp"
    "src/tool/migrate_apps/*.cpp"
)

file(GLOB TS_FILES ${CMAKE_CURRENT_SOURCE_DIR}/misc/translations/*.ts)

# 指定要用到的库
# 使用了 cmake 的 find_package 命令，查找库 Qt5Widgets 等，
# REQUIRED 参数表示如果没有找到则报错
# find_package 命令在找到并加载指定的库之后会设置一些变量，
# 常用的有：
# <库名>_FOUND          是否找到（Qt5Widgets_FOUND）
# <库名>_DIR            在哪个目录下找到的（Qt5Widgets_DIR）
# <库名>_INCLUDE_DIRS   有哪些头文件目录（Qt5Widgets_INCLUDE_DIRS）
# <库名>_LIBRARIES      有哪些库文件（Qt5Widgets_LIBRARIES）

find_package(DtkWidget REQUIRED)
find_package(Qt5 REQUIRED COMPONENTS Widgets Concurrent X11Extras DBus Network)

# find_package 命令还可以用来加载 cmake 的功能模块
# 并不是所有的库都直接支持 cmake 查找的，但大部分都支持了 pkg-config 这个标准，
# 因此 cmake 提供了间接加载库的模块：FindPkgConfig， 下面这行命令表示加载 FindPkgConfig 模块，
# 这个 cmake 模块提供了额外的基于 “pkg-config” 加载库的能力
# 执行下面的命令后后会设置如下变量，不过一般用不到：
# PKG_CONFIG_FOUND            pkg-config 可执行文件是否找到了
# PKG_CONFIG_EXECUTABLE       pkg-config 可执行文件的路径
# PKG_CONFIG_VERSION_STRING   pkg-config 的版本信息

set(INCLUDE_DIRECTORIES
    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
)

set(LINK_LIBRARIES
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
)

add_compile_definitions(CVERSION="${CVERSION}")

add_executable(${PROJECT_NAME}
    ${CORE_SRCS}
    ${SETTINGS_SRCS}
    ${WIDGETS_SRCS}
    ${TOOL_SRCS}
    ${QM_FILES}
    misc/resource.qrc
)

# Generate QM files
# For qt_*_translation don't work.
execute_process(COMMAND lupdate ${CMAKE_CURRENT_SOURCE_DIR}/src -ts ${TS_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/misc/translations)
execute_process(COMMAND lrelease ${TS_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/misc/translations)
file(GLOB QM_FILES "${CMAKE_CURRENT_SOURCE_DIR}/misc/translations/*.qm")

target_include_directories(${PROJECT_NAME} PUBLIC
    ${INCLUDE_DIRECTORIES}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${LINK_LIBRARIES}
)

# 设置安装路径的前缀(默认为"/usr/local")
set(CMAKE_INSTALL_PREFIX "/usr")

# icon
install(FILES misc/icons/upgrade-tool.svg DESTINATION share/icons/hicolor/scalable/apps)

# desktop file
install(FILES misc/deepin-system-upgrade-tool.desktop  DESTINATION share/applications)

# plymouth files
install(DIRECTORY misc/plymouth/themes/deepin-upgrade DESTINATION share/plymouth/themes/)

# translation files
install(FILES ${QM_FILES} DESTINATION share/${PROJECT_NAME}/translations)

# 设置执行 make install 时哪个目标应该被 install 到哪个位置
install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== debian/changelog ===
deepin-system-upgrade (6.0.2.3-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Thu, 02 Mar 2023 09:07:55 +0800

deepin-system-upgrade (6.0.2.2) unstable; urgency=medium

  * Initial release

 -- Xin Lin <linxin@uniontech.com>  Sat, 27 Aug 2022 13:45:29 +0800

## deepin-system-upgrade 6.0.3

=== src/deepin-system-upgrade-daemon/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

cmake_minimum_required(VERSION 3.9)

set(DAEMON_NAME "deepin-system-upgrade-daemon")
set(GOPATH_DIR "gopath")
set(GO_CODE "/usr/share/gocode")
set(PROG_UPGRADE ${DAEMON_NAME})

if(EXISTS ${GOPATH_DIR}/src/${DAEMON_NAME})
    exec_program(COMMAND rm -rf ${CMAKE_CURRENT_SOURCE_DIR}/${GOPATH_DIR})
endif()

    execute_process(COMMAND mkdir -p ${CMAKE_CURRENT_SOURCE_DIR}/${GOPATH_DIR}/src/${DAEMON_NAME})
    execute_process(COMMAND ln -sf ${CMAKE_CURRENT_SOURCE_DIR}/pkg ${CMAKE_CURRENT_SOURCE_DIR}/${GOPATH_DIR}/src/${DAEMON_NAME})
    execute_process(COMMAND ln -sf ${CMAKE_CURRENT_SOURCE_DIR}/cmd ${CMAKE_CURRENT_SOURCE_DIR}/${GOPATH_DIR}/src/${DAEMON_NAME})


string(CONCAT GOPATH_LIST ${CMAKE_CURRENT_SOURCE_DIR}/${GOPATH_DIR} ":" ${GO_CODE})

set(GOPATH
    $ENV{GOPATH}
    ${GOPATH_LIST}
)

set(CMAKE_GO_FLAGS -gcflags \"-N -l\")

project(${PROJECT_NAME} Go) # select GO compile

include(cmake/golang.cmake)

set(DAEMON_SRCS
    "cmd/${DAEMON_NAME}/main.go"
)

add_go_executable(${DAEMON_NAME} ${DAEMON_SRCS})

# 设置安装路径的前缀(默认为"/usr")
set(CMAKE_INSTALL_PREFIX "/usr")

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${DAEMON_NAME} DESTINATION sbin)

install(FILES configs/dbus/org.deepin.SystemUpgrade1.conf DESTINATION share/dbus-1/system.d)
install(FILES configs/dbus/org.deepin.SystemUpgrade1.service DESTINATION share/dbus-1/system-services)

install(FILES configs/backup.yaml DESTINATION /etc/deepin-system-upgrade)
install(FILES configs/config.yaml DESTINATION /etc/deepin-system-upgrade)
install(FILES configs/upgrade.yaml DESTINATION /etc/deepin-system-upgrade)

=== src/deepin-system-upgrade-daemon/Makefile ===
PRJ=deepin-system-upgrade-daemon
PROG_UPGRADER=${PRJ}
PWD=$(shell pwd)
GOCODE=/usr/share/gocode
GOPATH_DIR=gopath
CURRENT_DIR=$(nodir $(shell pwd))

export GO111MODULE=off

all:build

prepare:
	@if [ ! -d ${GOPATH_DIR}/src/${PRJ} ]; then \
		mkdir -p ${GOPATH_DIR}/src/${PRJ}; \
		ln -sf ${PWD}/pkg ${GOPATH_DIR}/src/${PRJ}; \
		ln -sf ${PWD}/cmd ${GOPATH_DIR}/src/${PRJ}; \
	fi

$(info, $(GOPATH))
$(warning, $(GOPATH))
$(error, $(GOPATH))

build: prepare

	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} go build -o ${PWD}/${PROG_UPGRADE}  ${PRJ}/cmd/${PROG_UPGRADER}
	rm -rf ${GOPATH_DIR}


clean: 
	rm -rf ${PWD}/${PROG_UPGRADER}

rebuild: clean build

=== debian/changelog ===
deepin-system-upgrade (6.0.3-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Sun, 23 Apr 2023 13:44:35 +0800

deepin-system-upgrade (6.0.3) unstable; urgency=medium

  * fix: system upgrade failed
  * chore: modify title

 -- Xin Lin <linxin@uniontech.com>  Sun, 23 Apr 2023 11:02:30 +0800

deepin-system-upgrade (6.0.2.4) unstable; urgency=medium

  * fix bugs
  * develop:modify the application migration process
  * develop:add dialog before backuping current system

 -- Xin Lin <linxin@uniontech.com>  Tue, 11 Apr 2023 16:00:48 +0800

=== debian/control ===
Source: deepin-system-upgrade
Section: utils
Priority: optional
Maintainer: LinuxDeepin <linuxdeepin@deepin.org>
Build-Depends:
  debhelper-compat (= 11),
  cmake,
  golang-any,
  golang-yaml.v2-dev,
  golang-dbus-dev,
  golang-github-linuxdeepin-go-lib-dev,
  libdtkwidget-dev,
  libdtkgui-dev,
  qtbase5-dev,
  qttools5-dev-tools
Standards-Version: 4.1.3
Homepage: http://www.deepin.org

Package: deepin-system-upgrade
Architecture: any
Depends:deepin-upgrade-manager, ${shlibs:Depends}, ${misc:Depends}, plymouth-label, fuseiso, dpkg-repack, squashfs-tools
Description: system upgrade tool
 deepin system upgrade tool in Linux

=== debian/rules ===
#!/usr/bin/make -f

export GOCACHE := /tmp/gocache
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=qt5
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --

## deepin-system-upgrade 6.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(deepin-system-upgrade)

add_subdirectory("src/deepin-system-upgrade-tool")
add_subdirectory("src/deepin-system-upgrade-daemon")

=== debian/changelog ===
deepin-system-upgrade (6.0.4-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Wed, 17 May 2023 09:44:38 +0800

deepin-system-upgrade (6.0.4) unstable; urgency=medium

  * modify iso download url

 -- Xin Lin <linxin@uniontech.com>  Wed, 17 May 2023 09:34:22 +0800
